package com.its.api.its.service.vds;

import com.its.api.its.model.dto.vds.TbVdsCtlrSttsHsDto;
import com.its.api.its.model.entity.vds.TbVdsCtlrSttsHs;
import com.its.api.its.model.entity.vds.TbVdsCtlrSttsHsKey;
import com.its.api.its.repository.vds.TbVdsCtlrSttsHsRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVdsCtlrSttsHsService {

    private final TbVdsCtlrSttsHsRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbVdsCtlrSttsHs requireOne(TbVdsCtlrSttsHsKey id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVdsCtlrSttsHsDto> findAll() {
        List<TbVdsCtlrSttsHsDto> result = new ArrayList<>();
        List<TbVdsCtlrSttsHs> data = this.repo.findAll();
        for (TbVdsCtlrSttsHs entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbVdsCtlrSttsHsDto findById(TbVdsCtlrSttsHsKey id) {
        TbVdsCtlrSttsHs entity = requireOne(id);
        return entity.toDto();
    }

    /**
     * 상태 이력 조회
     * @param fromDt
     * @param toDt
     * @param ids
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVdsCtlrSttsHsDto> findAllByDateRange(String fromDt, String toDt, List<String> ids) {
        List<TbVdsCtlrSttsHsDto> result = new ArrayList<>();
        List<TbVdsCtlrSttsHs> data = this.repo.findAllByDateRange(fromDt, toDt, ids);
        if (data != null) {
            data.forEach(obj -> {
                if (obj.getVds() != null && ("N").equals(obj.getVds().getDelYn())) {
                    result.add(obj.toDto());
                }
            });
        }
        return result;
    }

    /**
     * 장애 이력 조회
     * @param fromDt
     * @param toDt
     * @param ids
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVdsCtlrSttsHsDto> findAllFailByDateRange(String fromDt, String toDt, List<String> ids) {
        List<TbVdsCtlrSttsHsDto> result = new ArrayList<>();
        List<TbVdsCtlrSttsHs> data = this.repo.findAllFailByDateRange(fromDt, toDt, ids);
        if (data != null) {
            data.forEach(obj -> {
                if (obj.getVds() != null && ("N").equals(obj.getVds().getDelYn())) {
                    result.add(obj.toDto());
                }
            });
        }
        return result;
    }
}
